<template>
    <el-collapse-item :name="index">
        <template #title>
            <div class="element-title">
                <el-button :icon="Close" size="small" type="danger" @click.stop="deleteElement(index)" />
                <el-input v-model="inputTitle" placeholder="Titre Element" maxlength="75" clearable @click.stop @keydown.space.stop
                            @input="updateElementTitle(index)" >
                    <template #prefix>
                        <el-tooltip placement="top-start">
                            <el-icon size="large" color="#606060">
                                <InfoFilled />
                            </el-icon>
                            <template #content>
                                {{ t("global.infoElementTitre")}}
                            </template>
                        </el-tooltip>
                    </template>
                </el-input>
                <div style="display: flex; align-items:center; gap: 10px;">
                    <el-tooltip placement="top-start">
                        <el-icon size="large">
                            <InfoFilled />
                        </el-icon>
                        <template #content>
                            {{ t("global.infoElementPonderation") }}
                        </template>
                    </el-tooltip>
                    <el-input-number v-model="localElement.ponderation" :min="1" :max="100" controls-position="right"
                                     @change="updateElementWeigth(index)" @click.stop />
                </div>
            </div>
        </template>
        <div class="tags">
            <el-tag v-for="(critere, index) of localElement.critere" :key="index" type="info" closable
                    :disable-transitions="false" @close="deleteCritere(index)">
                {{ critere.detail }}
            </el-tag>
            <el-input v-if="inputCritereVisible"
                      ref="InputCritereRef"
                      v-model="inputCritereValue"
                      class="input-add-tag"
                      size="small"
                      @keyup.enter="handleInputCritereConfirm"
                      @blur="handleInputCritereConfirm">
                <template #suffix>
                    <el-button :icon="Close" size="small" link @click="inputCritereVisible=false" />
                </template>
            </el-input>
            <el-button v-else size="small" @click="showInputCritere">
                {{t("global.addCritere")}}
            </el-button>
        </div>
        <div class="info-tags">
            <el-text size="small" type="info">{{ t("global.infoElementCritere") }}</el-text>
        </div>
        <el-collapse v-model="activeBaremes" class="baremes-container">
            <el-collapse-item>
                <template #title>
                    <el-tooltip placement="top-start">
                        <el-icon size="large" style="margin-right: 5px;">
                            <InfoFilled />
                        </el-icon>
                        <template #content>
                            {{ t("global.infoElementBareme") }}
                        </template>
                    </el-tooltip>
                    {{t("global.titreBareme")}}
                    <el-text type="info" size="small" style="margin: 0 0 0 5px;">(optionel)</el-text>
                </template>
                <div class="baremes">
                    <BaremeComp v-for="(bareme, index) of localElement.bareme" :bareme="bareme" :key="index" :index="index"
                                @delete-bareme="deleteBareme" @update-bareme-content="(content: string)=>updateBaremeContent(index, content)"
                                @update-bareme-min-value="updateBaremeMinValue" @update-bareme-max-value="updateBaremeMaxValue" @update-bareme-title="(content:string) => updateBaremeTitle(content, index)" />
                    <el-button type="success" plain :icon="Plus" class="btn-add-bareme" @click="addBareme(index)" />
                </div>
            </el-collapse-item>
        </el-collapse>
        <div class="tags">
            <el-tag v-for="(commentaire, index) of localElement.commentaire" :key="index" :disable-transitions="false" type="info" closable @close="deleteComment(index)">
                {{commentaire.commentaire}}
            </el-tag>
            <el-input v-if="inputCommentVisible"
                      ref="InputCommentRef"
                      v-model="inputCommentValue"
                      class="input-add-tag"
                      size="small"
                      @keyup.enter="handleInputCommentConfirm"
                      @blur="handleInputCommentConfirm">
                <template #suffix>
                    <el-button :icon="Close" size="small" link @click="inputCommentVisible=false" />
                </template>
            </el-input>
            <el-button v-else class="button-new-tag" size="small" @click="showInputComment">
                {{t("global.addCommentaire")}}
            </el-button>
        </div>
        <div class="info-tags">
            <el-text size="small" type="info">{{ t("global.infoElementCommentaire") }}</el-text>
        </div>
    </el-collapse-item>
</template>
<script lang="ts" setup>
    import { nextTick, ref, computed } from 'vue';
    import { ElInput } from 'element-plus'

    import { Element } from '@/types/entities/creation-grille/Element';

    import BaremeComp from '@/components/creation-grille/BaremeComponent.vue';
    import { Plus, Minus, InfoFilled, Close } from '@element-plus/icons-vue';
    import { Bareme } from '../../types/entities/creation-grille/Bareme';

    import {useI18n} from "vue3-i18n"

    const { t } = useI18n()

    // eslint-disable-next-line
    const props = defineProps<{
        element: Element,
        index: number
    }>();

    // eslint-disable-next-line
    const emit = defineEmits(['deleteCritere', 'addCritere', 'addBareme', 'deleteBareme', 'updateBaremeContent',
        'updateBaremeMinValue', 'updateBaremeMaxValue', 'deleteComment', 'addComment', 'updateElementTitle', 'updateElementWeigth', 'deleteElement', 'updateBaremeTitle'])


    const activeBaremes = ref([0]);

    const localElement = computed(() => props.element)
    const inputTitle = ref<string>(localElement.value.titre!);


    const inputCritereValue = ref<string>('')
    const inputCritereVisible = ref<boolean>(false)
    const InputCritereRef = ref<InstanceType<typeof ElInput>>()

    const inputCommentValue = ref<string>('')
    const inputCommentVisible = ref<boolean>(false)
    const InputCommentRef = ref<InstanceType<typeof ElInput>>()


    // Gestion Element

    const updateElementTitle = (index: number) => {
        emit('updateElementTitle', inputTitle.value, index)
    }

    const updateElementWeigth = (index: number) => {
        emit('updateElementWeigth', localElement.value.ponderation, index)
    }

    const deleteElement = (index: number) => {
        emit('deleteElement', index)
    }

    // Gestion Baremes

    const addBareme = (index: number) => {
        emit('addBareme', index)
    }

    const deleteBareme = (index: number) => {
        emit('deleteBareme', index)
    }

    const updateBaremeContent = (index: number, content:string) => {
        emit('updateBaremeContent', index, content)
    }

    const updateBaremeMinValue = (value: number|null, index:number) => {
        emit('updateBaremeMinValue', value, index)
    }

    const updateBaremeMaxValue = (value: number, index: number) => {
        emit('updateBaremeMaxValue', value, index)
    }

    const updateBaremeTitle = (content: string, index: number) => {
        emit('updateBaremeTitle', content, index)
    }

    // Gestion criteres

    const showInputCritere = () => {
        inputCritereVisible.value = true
        nextTick(() => {
            InputCritereRef.value!.input!.focus()
        })
    }
    const handleInputCritereConfirm = () => {
        if (inputCritereValue.value) {
            emit('addCritere', inputCritereValue.value)

            inputCritereVisible.value = false
            inputCritereValue.value = ''
        }

    }

    const deleteCritere = (index: number) => {
        emit('deleteCritere', index)
    }

    // Gestion commentaires
    const showInputComment = () => {
        inputCommentVisible.value = true
        nextTick(() => {
            InputCommentRef.value!.input!.focus()
        })
    }
    const handleInputCommentConfirm = () => {
        if (inputCommentValue.value) {
            emit('addComment', inputCommentValue.value)

            inputCommentVisible.value = false
            inputCommentValue.value = ''
        }

    }
    const deleteComment = (index: number) => {
        emit('deleteComment', index)
    }

</script>
<style scoped>
    .baremes-container{
        width: 85%;
        margin: 15px auto 0 auto;
    }

    .element-title {
        margin: 0 10px 0 10px;
        display: flex;
        flex-direction: row;
        flex-wrap: nowrap;
        align-items: center;
        gap: 10px;
    }
    
    .baremes {
        margin: 15px auto;
        display: flex;
        flex-wrap: wrap;
    }

    .max-baremes-text {
        margin: 0px 30px 10px 30px;
    }

    .btn-add-bareme {
        min-width: 225px;
        min-height: 235px;
        margin: 10px;
    }

    .tags {
        margin: 15px 0 0 15px;
        display: flex;
        flex-direction: row;
        flex-wrap: wrap;
        gap: 5px;
    }

    .info-tags {
        margin: 5px 0 0 15px;
    }
    .input-add-tag {
        min-width: 75px;
        width: fit-content;
    }
</style>
